using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace frmContrastEnhancement1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 

	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button btParameter;
		internal System.Windows.Forms.CheckBox cbEnable;
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private TIS.Imaging.FrameFilter filter;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btParameter = new System.Windows.Forms.Button();
			this.cbEnable = new System.Windows.Forms.CheckBox();
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// btParameter
			// 
			this.btParameter.Location = new System.Drawing.Point(280, 312);
			this.btParameter.Name = "btParameter";
			this.btParameter.TabIndex = 4;
			this.btParameter.Text = "Parameter";
			this.btParameter.Click += new System.EventHandler(this.btParameter_Click);
			// 
			// cbEnable
			// 
			this.cbEnable.Location = new System.Drawing.Point(8, 312);
			this.cbEnable.Name = "cbEnable";
			this.cbEnable.TabIndex = 3;
			this.cbEnable.Text = "Enable";
			this.cbEnable.CheckedChanged += new System.EventHandler(this.cbEnable_CheckedChanged);
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(8, 8);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.Size = new System.Drawing.Size(344, 288);
			this.icImagingControl1.TabIndex = 5;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(363, 352);
			this.Controls.Add(this.icImagingControl1);
			this.Controls.Add(this.btParameter);
			this.Controls.Add(this.cbEnable);
			this.Name = "Form1";
			this.Text = "Contrast Enhancement 1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();
			if (!icImagingControl1.DeviceValid)
				return;
	
			try 
			{
				filter = icImagingControl1.FrameFilterCreate("ContrastEnhancement", "");
				// Insert the frame filter in the device path of IC.
				icImagingControl1.DeviceFrameFilters.Add(filter);
				// Enable the filter
				cbEnable.Checked = true;
				// Initialize the Enable check box.
				filter.SetBoolParameter("Enable", cbEnable.Checked);
				icImagingControl1.LiveStart();
			}
			catch(Exception ex)
			{
				MessageBox.Show("Failed to load the frame filter!");
			}
		}
		
		private void cbEnable_CheckedChanged(object sender, System.EventArgs e)
		{
			filter.BeginParameterTransfer();
			filter.SetBoolParameter("Enable", cbEnable.Checked);
			filter.EndParameterTransfer();
		}
		private void btParameter_Click(object sender, System.EventArgs e)
		{
			filter.ShowDialog();
			if (filter.GetBoolParameter("Enable"))
				cbEnable.Checked = true;
			else
				cbEnable.Checked = false;

		}
	}
}
