using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MarkPixels1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 

	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		internal System.Windows.Forms.Button btParameter;
		internal System.Windows.Forms.CheckBox cbEnable;
		public TIS.Imaging.FrameFilter filter;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			this.btParameter = new System.Windows.Forms.Button();
			this.cbEnable = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(8, 8);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.Size = new System.Drawing.Size(376, 328);
			this.icImagingControl1.TabIndex = 0;
			// 
			// btParameter
			// 
			this.btParameter.Location = new System.Drawing.Point(312, 344);
			this.btParameter.Name = "btParameter";
			this.btParameter.TabIndex = 10;
			this.btParameter.Text = "Parameter";
			this.btParameter.Click += new System.EventHandler(this.btParameter_Click);
			// 
			// cbEnable
			// 
			this.cbEnable.Location = new System.Drawing.Point(8, 344);
			this.cbEnable.Name = "cbEnable";
			this.cbEnable.Size = new System.Drawing.Size(64, 24);
			this.cbEnable.TabIndex = 9;
			this.cbEnable.Text = "Enable";
			this.cbEnable.CheckedChanged += new System.EventHandler(this.cbEnable_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(394, 376);
			this.Controls.Add(this.btParameter);
			this.Controls.Add(this.cbEnable);
			this.Controls.Add(this.icImagingControl1);
			this.Name = "Form1";
			this.Text = "Mark Pixels 1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();
			if (!icImagingControl1.DeviceValid )
				return ;

			filter = icImagingControl1.FrameFilterCreate("Clipping", "");
            // Check for successful load of filter.
            if (filter == null)
            {
                MessageBox.Show("Failed to load the Clipping filter", "Mark Pixels 1", MessageBoxButtons.OK, MessageBoxIcon.Error);
                cbEnable.Checked = false;
                cbEnable.Enabled = false;
            }
            else
            {
                // Insert the frame filter in the display path of IC.
                icImagingControl1.DisplayFrameFilters.Add(filter);
                // Enable the filter
                filter.SetBoolParameter("Enable", cbEnable.Checked);
                // Initialize the Enable check box.
                cbEnable.Checked = true;
            }
			icImagingControl1.LiveStart();
		}
		
		private void btParameter_Click(object sender, System.EventArgs e)
		{
			filter.ShowDialog();
			cbEnable.Checked = filter.GetBoolParameter("Enable");
		}
		private void cbEnable_CheckedChanged(object sender, System.EventArgs e)
		{
			filter.BeginParameterTransfer();
			filter.SetBoolParameter("Enable", cbEnable.Checked);
			filter.EndParameterTransfer();
		}
	}
}
