// SaveRestorePropertiesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SaveRestoreProperties.h"
#include "SaveRestorePropertiesDlg.h"
#include ".\saverestorepropertiesdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSaveRestorePropertiesDlg dialog



CSaveRestorePropertiesDlg::CSaveRestorePropertiesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSaveRestorePropertiesDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSaveRestorePropertiesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_VIDEO, m_cStaticVideoWindow);
}

BEGIN_MESSAGE_MAP(CSaveRestorePropertiesDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDDEVICE, OnBnClickedDevice)
	ON_BN_CLICKED(IDPROPERTIES, OnBnClickedProperties)
	ON_BN_CLICKED(IDSAVE, OnBnClickedSave)
	ON_BN_CLICKED(IDRESTORE, OnBnClickedRestore)
END_MESSAGE_MAP()


// CSaveRestorePropertiesDlg message handlers

BOOL CSaveRestorePropertiesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// Assign this window to the Grabber object for live video display.
	m_cGrabber.setHWND(m_cStaticVideoWindow.m_hWnd);

	// Adjust the live video to the size of the window.
	CRect rect;
	m_cStaticVideoWindow.GetClientRect( &rect);
	m_cGrabber.setDefaultWindowPosition(false);
	m_cGrabber.setWindowSize(rect.Width(), rect.Height());
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSaveRestorePropertiesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSaveRestorePropertiesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSaveRestorePropertiesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



//Show the device settings build in dialog to select a device
//and display the image data stream if the selected video device is valid.
void CSaveRestorePropertiesDlg::OnBnClickedDevice()
{
	if(m_cGrabber.isDevValid() && m_cGrabber.isLive())
	{
		m_cGrabber.stopLive();
	}

	m_cGrabber.showDevicePage(this->m_hWnd);

	if(m_cGrabber.isDevValid())
	{
		m_cGrabber.startLive();
	}
}


//Show the device properties build-in dialog.
void CSaveRestorePropertiesDlg::OnBnClickedProperties()
{
	if( m_cGrabber.isDevValid())
	{
		m_cGrabber.showVCDPropertyPage(this->m_hWnd);
	}
}

//Save device to device.xml if possible.
void CSaveRestorePropertiesDlg::OnBnClickedSave()
{
	if( m_cGrabber.isDevValid())
	{
		m_cGrabber.saveDeviceStateToFile("device.xml");
	}
}

//Restore the device and display image data stream if possible.
void CSaveRestorePropertiesDlg::OnBnClickedRestore()
{
	if(m_cGrabber.isDevValid() && m_cGrabber.isLive())
	{
		m_cGrabber.stopLive();
	}

	if( m_cGrabber.loadDeviceStateFromFile( "device.xml"))
	{
		if( m_cGrabber.isDevValid())
			m_cGrabber.startLive();
	}
}
